/*
   http://codegolf.stackexchange.com/questions/37071/implement-an-8-bit-adder
*/
#include <stdio.h>

unsigned char add(unsigned char a, unsigned char b)
{
   unsigned char c, d;

   c =  a ^ b;         /* 1 */
   d = (a & b) << 1;

   a =  c ^ d;         /* 2 */
   b = (c & d) << 1;

   c =  a ^ b;         /* 3 */
   d = (a & b) << 1;

   a =  c ^ d;         /* 4 */
   b = (c & d) << 1;

   c =  a ^ b;         /* 5 */
   d = (a & b) << 1;

   a =  c ^ d;         /* 6 */
   b = (c & d) << 1;

   c =  a ^ b;         /* 7 */
   d = (a & b) << 1;

   a =  c ^ d;         /* 8 */

   return a;
}



int main()
{
   unsigned char i, j;
   for (i = 0; i < 255; i++)
   {
      for (j = 0; j < 255; j++)
      {
         if ( add(i, j) != (unsigned char)(i + j) )
         {
            printf("Failed on %d + %d = %d\n", i, j, add(i, j));
         }
      }
   }
   return 0;
}
